Method: properties.getMetadata

  • The getMetadata method returns metadata for dimensions and metrics available in Google Analytics reporting methods.

  • A Google Analytics GA4 Property Identifier must be specified in the request to get metadata including Custom dimensions and metrics.

  • The metadata response includes both Custom dimensions and metrics specific to a property and Universal metadata applicable to any property.

  • The request body for this method must be empty, and a successful response contains data including dimensions and metrics.

  • The DimensionMetadata and MetricMetadata objects provide details like API name, UI name, description, and whether they are custom.

Returns metadata for dimensions and metrics available in reporting methods. Used to explore the dimensions and metrics. In this method, a Google Analytics property identifier is specified in the request, and the metadata response includes Custom dimensions and metrics as well as Universal metadata.

For example if a custom metric with parameter name levels_unlocked is registered to a property, the Metadata response will contain customEvent:levels_unlocked. Universal metadata are dimensions and metrics applicable to any property such as country and totalUsers.

HTTP request

GET https://analyticsdata.googleapis.com/v1alpha/{name=properties/*/metadata}

The URL uses gRPC Transcoding syntax.

Path parameters

Parameters
name

string

Required. The resource name of the metadata to retrieve. This name field is specified in the URL path and not URL parameters. Property is a numeric Google Analytics property identifier. To learn more, see where to find your Property ID.

Example: properties/1234/metadata

Set the Property ID to 0 for dimensions and metrics common to all properties. In this special mode, this method will not return custom dimensions and metrics.

Request body

The request body must be empty.

Response body

The dimensions, metrics and comparisons currently accepted in reporting methods.

If successful, the response body contains data with the following structure:

JSON representation
{
  "name": string,
  "dimensions": [
    {
      object (DimensionMetadata)
    }
  ],
  "metrics": [
    {
      object (MetricMetadata)
    }
  ],
  "comparisons": [
    {
      object (ComparisonMetadata)
    }
  ],
  "conversions": [
    {
      object (ConversionMetadata)
    }
  ]
}
Fields
name

string

Resource name of this metadata.

dimensions[]

object (DimensionMetadata)

The dimension descriptions.

metrics[]

object (MetricMetadata)

The metric descriptions.

comparisons[]

object (ComparisonMetadata)

The comparison descriptions.

conversions[]

object (ConversionMetadata)

The conversion descriptions.

Authorization scopes

Requires one of the following OAuth scopes:

  • https://www.googleapis.com/auth/analytics.readonly
  • https://www.googleapis.com/auth/analytics

DimensionMetadata

Explains a dimension.

JSON representation
{
  "apiName": string,
  "uiName": string,
  "description": string,
  "deprecatedApiNames": [
    string
  ],
  "customDefinition": boolean,
  "category": string,
  "sections": [
    enum (Section)
  ]
}
Fields
apiName

string

This dimension's name. Usable in Dimension's name. For example, eventName.

uiName

string

This dimension's name within the Google Analytics user interface. For example, Event name.

description

string

Description of how this dimension is used and calculated.

deprecatedApiNames[]

string

Still usable but deprecated names for this dimension. If populated, this dimension is available by either apiName or one of deprecatedApiNames for a period of time. After the deprecation period, the dimension will be available only by apiName.

customDefinition

boolean

True if the dimension is custom to this property. This includes user, event, & item scoped custom dimensions; to learn more about custom dimensions, see https://support.google.com/analytics/answer/14240153. This also include custom channel groups; to learn more about custom channel groups, see https://support.google.com/analytics/answer/13051316.

category

string

The display name of the category that this dimension belongs to. Similar dimensions and metrics are categorized together.

sections[]

enum (Section)

Specifies the Google Analytics sections this dimension applies to.

MetricMetadata

Explains a metric.

JSON representation
{
  "apiName": string,
  "uiName": string,
  "description": string,
  "deprecatedApiNames": [
    string
  ],
  "type": enum (MetricType),
  "expression": string,
  "customDefinition": boolean,
  "blockedReasons": [
    enum (BlockedReason)
  ],
  "category": string,
  "sections": [
    enum (Section)
  ]
}
Fields
apiName

string

A metric name. Usable in Metric's name. For example, eventCount.

uiName

string

This metric's name within the Google Analytics user interface. For example, Event count.

description

string

Description of how this metric is used and calculated.

deprecatedApiNames[]

string

Still usable but deprecated names for this metric. If populated, this metric is available by either apiName or one of deprecatedApiNames for a period of time. After the deprecation period, the metric will be available only by apiName.

type

enum (MetricType)

The type of this metric.

expression

string

The mathematical expression for this derived metric. Can be used in Metric's expression field for equivalent reports. Most metrics are not expressions, and for non-expressions, this field is empty.

customDefinition

boolean

True if the metric is a custom metric for this property.

blockedReasons[]

enum (BlockedReason)

If reasons are specified, your access is blocked to this metric for this property. API requests from you to this property for this metric will succeed; however, the report will contain only zeros for this metric. API requests with metric filters on blocked metrics will fail. If reasons are empty, you have access to this metric.

To learn more, see Access and data-restriction management.

category

string

The display name of the category that this metrics belongs to. Similar dimensions and metrics are categorized together.

sections[]

enum (Section)

Specifies the Google Analytics sections this metric applies to.

BlockedReason

Justifications for why this metric is blocked.

Enums
BLOCKED_REASON_UNSPECIFIED Will never be specified in API response.
NO_REVENUE_METRICS If present, your access is blocked to revenue related metrics for this property, and this metric is revenue related.
NO_COST_METRICS If present, your access is blocked to cost related metrics for this property, and this metric is cost related.

ComparisonMetadata

The metadata for a single comparison.

JSON representation
{
  "apiName": string,
  "uiName": string,
  "description": string
}
Fields
apiName

string

This comparison's resource name. Usable in Comparison's comparison field. For example, 'comparisons/1234'.

uiName

string

This comparison's name within the Google Analytics user interface.

description

string

This comparison's description.

ConversionMetadata

The metadata for a single conversion.

JSON representation
{
  "conversionAction": string,
  "displayName": string
}
Fields
conversionAction

string

The unique identifier of the conversion action. This ID is used to specify which conversions to include in a report by populating the conversionActions field in the ConversionsSpec of a report request. For example, 'conversionActions/1234'.

displayName

string

This conversion's name within the Google Analytics user interface.